﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Win32;

namespace ExportCegidParam.Outils
{
    /// <summary>
    /// Classe contenant des méthode static pour tester la base de registre
    /// </summary>
    public class Registre
    {

        /// <summary>
        /// Fonction qui lit le mot de passe dans la base des registres windows
        /// </summary>
        public static void ReadValue(ref string sPassWord)
        {
            Microsoft.Win32.RegistryKey Nkey = Microsoft.Win32.Registry.CurrentUser;
            try{
                RegistryKey valKey = Nkey.OpenSubKey("Software\\MyApp\\MyKey", true);
                if (valKey == null){
                    sPassWord = "";
                }
                else{
                    sPassWord = (string)valKey.GetValue("MyKeyValue");
                    valKey.Close();
                }
            }
            catch (Exception ex){
                sPassWord = "";
                throw new ApplicationException(ex.Message);
            }
            finally{
                Nkey.Close();
            }
        }

        /// <summary>
        /// Fonction qui écrit le mot de passe dans la base de registre windows
        /// </summary>
        /// <param name="sPassWord"></param>
        public static void WriteValue(string sPassWord)
        {
            Microsoft.Win32.RegistryKey Nkey = Microsoft.Win32.Registry.CurrentUser;
            try{
                Microsoft.Win32.RegistryKey valKey = Nkey.OpenSubKey("Software\\MyApp\\MyKey", true);
                if (valKey == null){
                    Nkey.CreateSubKey("Software\\MyApp\\MyKey");
                }
                valKey.SetValue("MyKeyValue", sPassWord);
            }
            catch (Exception ex){
                throw new ApplicationException(ex.Message);
            }
            finally{
                Nkey.Close();
            }
        }


        /// <summary>
        /// Return a bool, with key application 
        /// </summary>
        /// <param name="@strKey"></param>
        /// <returns></returns>
        public static bool CheckAppInstalled(string @strKey)
        {
            bool retour = false;
            try
            {
                using (RegistryKey Nkey = Registry.CurrentUser)
                {
                    RegistryKey valKey = Nkey.OpenSubKey(strKey, false);
                    if (valKey != null) {
                        retour = true;
                    }
                }
            }
            catch (Exception ex) {
                throw new ApplicationException(ex.Message);
            }
            return retour;
        }
    }
}
