﻿using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;


namespace Serialisation.Binary
{
    internal class SerialiseurBinaire
    {

        #region "Gestion du singleton"
        private static IFormatter _formatter; 
        private static SerialiseurBinaire _instance = null;

        private SerialiseurBinaire()
        {
            _formatter = new BinaryFormatter();
        }

        public static SerialiseurBinaire getInstance()
        {
            if (SerialiseurBinaire._instance == null)
            {
                SerialiseurBinaire._instance = new SerialiseurBinaire();
            }
            return SerialiseurBinaire._instance;
        }
        #endregion

        internal void serialiser<T>(T obj, string pathFile)
        {
            try
            {
                using (FileStream fs = new FileStream(pathFile, FileMode.Create, FileAccess.Write, FileShare.None))
                {
                    _formatter.Serialize(fs, obj);
                }
                   
            }
            catch (Exception ex) { throw new ApplicationException(string.Format("Une erreur est survenue Lors de la : {0}", ex.Message)); }
        }

    }
}
