﻿using System;
using System.Collections.Generic;

namespace Serialisation.CSV
{
    internal class SerialiseurCSV
    {
        #region Singleton
        private static SerialiseurCSV _instance = null;
        private SerialiseurCSV()
        {
        }

        public static SerialiseurCSV getInstance()
        {
            if (SerialiseurCSV._instance == null)
            {
                SerialiseurCSV._instance = new SerialiseurCSV();
            }
            return SerialiseurCSV._instance;
        }
        #endregion

        internal void Serialiser(string pathfile, ExportCegidParam.BO.DataExport donnees, ExportCegidParam.BO.Parametrage parametrage)
        {
            try
            {
                using (System.IO.StreamWriter sw = new System.IO.StreamWriter(pathfile, false, parametrage.Encodage))
                {
                    string strTmp = "";
                    //parametrage.Entete = true;
                    //parametrage.Separateur = '|';
                    if (parametrage.Entete)
                    {
                        foreach (string entete in donnees.Entetes)
                        {
                            strTmp += entete + parametrage.Separateur;
                        }
                        sw.WriteLine(strTmp.Substring(0, strTmp.Length - 1));
                    }
                    foreach (ExportCegidParam.BO.Ligne ligne in donnees.Lignes)
                    {
                        strTmp = "";
                        foreach (ExportCegidParam.BO.Element element in ligne.Elements)
                        {
                            strTmp += element.Value + parametrage.Separateur;
                        }
                        sw.WriteLine(strTmp.Substring(0, strTmp.Length - 1));
                    }
                    sw.Flush();
                    sw.Close();
                }
            }
            catch (Exception ex)
            {
                throw new ApplicationException("Une erreur est survenue lors de la génération du fichier CSV ," + ex.Message);
            }
        }
    }
}
