﻿using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

namespace Serialisation.SOAP
{
    internal class SerialiseurSoap
    {
        #region "Gestion du singleton"
        private static IFormatter _formatter;
        private static SerialiseurSoap _instance = null;
        private SerialiseurSoap()
        {
            _formatter = new SoapFormatter();
        }

        public static SerialiseurSoap getInstance()
        {
            if (SerialiseurSoap._instance == null)
            {
                SerialiseurSoap._instance = new SerialiseurSoap();
            }
            return SerialiseurSoap._instance;
        }
        #endregion

        internal void Serialiser<T>(T obj, string pathFile)
        {
            try
            {
                using (FileStream fs = new FileStream(pathFile, FileMode.Create, FileAccess.Write, FileShare.None))
                {
                    _formatter.Serialize(fs, obj);
                }

            }
            catch (Exception ex) { throw new ApplicationException(string.Format("Une erreur est survenue Lors de la : {0}", ex.Message)); }
        }

        internal T Deserialiser<T>(string pathFile)
        {
            T objetDeserialisee = default(T);
            try
            {
                using (FileStream fs = new FileStream(pathFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    objetDeserialisee = (T)_formatter.Deserialize(fs);
                    return objetDeserialisee;
                }
            }
            catch (Exception ex) { throw new ApplicationException(string.Format("Une erreur est survenue: {0}", ex.Message)); }
        }

    }

}
