﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

using System.Xml;
using System.IO;

namespace Serialisation.XML
{
    internal class SerialiseurXML
    {

        #region Singleton
        private static XmlSerializer _formatter;
        private static SerialiseurXML _instance = null;
        private SerialiseurXML()
        {
            _formatter = new XmlSerializer(typeof(ExportCegidParam.BO.DataExport));
        }

        public static SerialiseurXML getInstance()
        {
            if (SerialiseurXML._instance == null)
            {
                SerialiseurXML._instance = new SerialiseurXML();
            }
            return SerialiseurXML._instance;
        }
        #endregion

        internal void Serialiser<T>(T obj, string pathFile)
        {
            try
            {
                using (FileStream fs = new FileStream(pathFile, FileMode.Create, FileAccess.Write, FileShare.None))
                {
                    _formatter.Serialize(fs, obj);
                }
            }
            catch (Exception ex) { throw new ApplicationException(string.Format("Une erreur est survenue Lors de la Serialisation XML : {0}", ex.Message)); }
        }
    }
}
